#!/usr/bin/perl
BEGIN {
	push @INC, "./nanalib";
}
use CGI::Carp qw(fatalsToBrowser);
use Fcntl;
use GDBM_File;
#use Digest::SHA qw(sha1_hex);
use Digest::SHA qw(sha1);
use IDNA::Punycode;
use CGI;
use Nana::HTTP;
use Jcode;

my $urldb_path="./urldb";
my $memberdb_path="./member";
my $qCGI;

my $totalcount="?ac";
my $daycount="?ac";
my $urlcount="?count";
my $kwcount="?kwcount";
my $orgstringcount="?orglen";
my $shortstringcount="?srtlen";

my $addurllist="?url";
my $addkeywordlist="?key";

my $id_name="-id.gdbm";
my $url_name="-url.gdbm";
my $sys_name="-sys.gdbm";

my $try=62;
my $script="./s.cgi";
my $img="http://$ENV{HTTP_HOST}";

$::isurl=q{(\b(?:https?|ftp|news)://(?:(?:[-_.!~*'()a-zA-Z0-9;:&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*@)?(?:(?:(?:[a-zA-Z0-9](?:[-_a-zA-Z0-9]*[a-zA-Z0-9])?|[-_0-9a-zA-Z\x80-\xfd](?:[-_0-9a-zA-Z\x80-\xfd]*[-_0-9a-zA-Z\x80-\xfd])?)\.)*[a-zA-Z](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.?|[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)(?::[0-9]*)?(?:/(?:[-_.!~*'a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*(?:;(?:[-_.!~*'a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)*(?:/(?:[-_.!~*'a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*(?:;(?:[-_.!~*'a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)*)*)?(?:\?(?:[-_.!~*'a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)?(?:\x23(?:[-_.!~*'a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)?)};

$::isurl_puny='[\x80-\xfd]';

my %urldb;
my %iddb;
my %sysdb;

my $udate;

&getbasehref;
&main;

sub main {
	my $path;
	my $f;
	my $urldb_file;
	my $member_file;
	my $page="pc.html";
	foreach my $i (0x00 .. 0xFF) {
		$::_urlescape{chr($i)} = sprintf('%%%02x', $i);
		$::_dbmname_encode{chr($i)} = sprintf('%02X', $i);
		$::_dbmname_decode{sprintf('%02X', $i)} = chr($i);
	}
	$::_urlescape{chr(32)} ='+';
	$udate=int((time+9*3600) / 86400);

	&opendb($ENV{HTTP_HOST});
	$ENV{SCRIPT}=$script;
	$ENV{IMG}=$img;
	$ENV{COUNT}=$sysdb{$totalcount}+1;
	$sysdb{$totalcount}=$ENV{COUNT};
	$ENV{TODAYCOUNT}=$sysdb{"$daycount" . $udate};
	$sysdb{"$daycount" . $udate}=$ENV{TODAYCOUNT}+1;
	$ENV{YESTERDAYCOUNT}=$sysdb{"$daycount" . @{[$udate-1]}}+0;
	$ENV{COUNTS}=$sysdb{$urlcount}+0;
	$ENV{KWCOUNTS}=$sysdb{$kwcount}+0;
	$ENV{STRINGS}=$sysdb{$orgstringcount}+0-$sysdb{$shortstringcount}+0;

	if($ENV{QUERY_STRING} ne '' || $ENV{REQUEST_METHOD} eq "POST") {
		&init_form;
		if($ENV{QUERY_STRING} eq "list" || $::form{mode} eq "list") {
			$page="pc_list.html";
			$ENV{LIST}=&list("list",$addurllist);
		} elsif($ENV{QUERY_STRING} eq "keywords" || $::form{mode} eq "keywords") {
			$page="pc_list.html";
			$ENV{LIST}=&list("keywords",$addkeywordlist);
		} else {
			if($::form{q} ne '') {
				$id=&createid($::form{q});
			}
			$ENV{ORGURL}=$::form{q};
			$ENV{KEYWORD}=$::form{q};
			$ENV{ID}=$id;
			$ENV{URL}="http://$ENV{HTTP_HOST}/$id";
			if($::form{q}=~/$::isurl/o) {
				if($id eq "") {
					$page="pc_resulterr.html";
				} else {
					$page="pc_result.html";
				}
			} else {
				$page="pc_resultsearch.html";
			}
		}
	}
	if($ENV{PATH_INFO} ne '') {
		$path=$ENV{PATH_INFO};
		$path=~s/[\.\,\|\/]//g;
	}
	if($ENV{QUERY_STRING} eq '' && $ENV{REQUEST_METHOD} eq "GET") {
		if($ENV{PATH_INFO} eq "") {
		}
	}
	&page($page);
	&closedb;
}

sub list {
	my($mode, $dbname)=@_;
	my $pages=100;

	if($::form{p} eq '') {
		$p=1;
	} else {
		$p=$::form{p};
	}

	my $db;
	my @db;
	my $c=0;
	my $i=0;
	do {
		$db=$sysdb{"$dbname@{[$udate-$i]}"};
		my @tmp=split(/\n/,$db);
		foreach(@tmp) {
			push(@db,$_);
			$c++;
		}
		$i++;
	} while($c <= $pages * $p && $c ne 0);

	@db=reverse @db;
	my $html;
	for($i=$p * $pages - $pages; $i<=$p * $pages; $i++) {
#$a=$sysdb{"$dbname$udate"};
$a=$db[0];
$html.="$i / $dbname / $udate / aa$a / $sysdb{$dbname . $udate};";
		my($t,$i)=split(/\t/,$db[$i]);
		my($title,$url,$click,$log)=$urldb{$i};
		last if($url eq "");
		$title=substr($title, 1);
		$html.=<<EOM;
<a href="http://$ENV{HTTP_HOST}/$i">
@{[&date($t)]} @{[length($title)>50 ? substr($title,0,50) . "..." : $title]} ($click)
</a><br />
EOM
	}
	return $html;
}

sub createid {
	my($url)=shift;
	my $url=$::form{q};
	my $punyurl;

	if($url=~/$::isurl/o) {
		my $count=$ENV{COUNTS}+0;
		if($url=~/$::isurl_puny/) {
			$punyurl=$url;
			$url=&make_link_puny($url);
		}
#$::proxy_host="192.168.1.1";
#$::proxy_port="3128";

		my $http=new Nana::HTTP('ua'=>"URL shorten of http://$ENV{HTTP_HOST}/");
		my ($result, $stream) = $http->get($url);
		$stream=~s/[\xd\xa]//g;
		&Jcode::convert($stream, 'utf8');
		return "" if($result != 0);
		if($stream=~/[Tt][Ii][Tt][Ll][Ee]/) {
			$stream=~s/<\/[Tt][Ii][Tt][Ll][Ee]>.*//g;
			$stream=~s/.*<[Tt][Ii][Tt][Ll][Ee]>//g;
			$title=$stream;
		} else {
			$title=$url;
			$title=~s/(https?|ftp|news)\:\/\///g;
		}
		my $c=0;
		if($iddb{$url} ne '') {
			$id=$iddb{$url};
			my($t, $url, $counter, $log)=$urldb{$id};
#			return "" if($title=~/^u/);
#			$title=~s/^.//g;
			$ENV{TITLE}=$title;
		} else {
			$count++;
			my $len=$count;
			my $keylen;
			my $tmp=1;
			for($i=1; $i<=30; $i++) {
				$keylen=$i;
				$tmp=$tmp * $try;
				last if($count < $tmp);
			}
			do {
				$hashedurl=sha1($c++ . time . time . time .$url);
				$cmpedurl=substr(&trip($hashedurl),0, $keylen);
				my($u,$c,$l)=split(/\n/,$urldb{$cmpedurl});
				$urldb{$cmpedurl}="u$title\n$url\n$c\n$l";
			} while($u ne ''); #defined($urldb{$cmpedurl}));
			if($u ne $url) {
				$hashedurl=sha1($c++ . time . time . time .$url);
				$cmpedurl=substr(&trip($hashedurl),0, $keylen);
				$urldb{$cmpedurl}="u$title\n$url\n0\n";
				$ENV{TITLE}=$title;
				$iddb{$url}=$cmpedurl;
				$sysdb{$urlcount}=$count;
				$sysdb{$orgstringcount}+=0 + length($url);
				$sysdb{$shortstringcount}+=0 + length($iddb{$url});
				$id=$cmpedurl;
				$ENV{COUNTS}=$sysdb{$urlcount}+0;
				$ENV{STRINGS}=$sysdb{$orgstringcount}+0-$sysdb{$shortstringcount}+0;
				$sysdb{"$addurllist$udate"}.=time . "\t$cmpedurl\n";
			}
		}
		return $id;
	} else {
		my $count=$ENV{KWCOUNTS}+0;
		my $c=0;
		if($iddb{$url} ne '') {
			$id=$iddb{$url};
		} else {
			$count++;
			my $len=$count;
			my $keylen;
			my $tmp=1;
			for($i=1; $i<=30; $i++) {
				$keylen=$i;
				$tmp=$tmp * $try;
				last if($count < $tmp);
			}
			do {
				$hashedurl=sha1($c++ . time . time . time .$url);
				$cmpedurl=substr(&trip($hashedurl),0, $keylen);
				my($u,$c,$l)=split(/\n/,$urldb{$cmpedurl});
			} while($u ne ''); #defined($urldb{$cmpedurl}));
			if($u ne $url) {
				$hashedurl=sha1($c++ . time . time . time .$url);
				$cmpedurl=substr(&trip($hashedurl),0, $keylen);
				$urldb{$cmpedurl}="k\n$url\n0\n";
				$iddb{$url}=$cmpedurl;
				$sysdb{$kwcount}=$count;
				$sysdb{$orgstringcount}+=0 + length($url);
				$sysdb{$shortstringcount}+=0 + length($iddb{$url});
				$id=$cmpedurl;
				$ENV{KWCOUNTS}=$sysdb{$kwcount}+0;
				$ENV{STRINGS}=$sysdb{$orgstringcount}+0-$sysdb{$shortstringcount}+0;
				$sysdb{"$addkeywordlist$udate"}.= time . "\t$cmpedurl\n";
			}
		}
		return $id;
	}
}

sub opendb {
	my($f)=shift;
	$f=~s/[\.\,\|\/]//g;
	$urldb_file="$urldb_path/$f$id_name";
	$iddb_file="$urldb_path/$f$url_name";
	$sysdb_file="$urldb_path/$f$sys_name";
	&dbopen(\%urldb, $urldb_file, "w");
	&dbopen(\%iddb, $iddb_file, "w");
	&dbopen(\%sysdb, $sysdb_file, "w");
}
sub closedb {
	&dbclose(\%urldb);
	&dbclose(\%iddb);
	&dbclose(\%sysdb);
}

sub page {
	my ($page)=@_;
	my $out;
	$out.=&readfile("pc_header.html");
	$out.=&readfile($page);
	$out.=&readfile("pc_footer.html");
	foreach (keys %ENV) {
		$out=~s/\$$_/$ENV{$_}/g;
	}
#	$out=~s/<img/\<\!\-\-img/g;
	&content_output(&http_header("Content-type: text/html"), $out);
}

sub readfile {
	my ($file)=shift;
	my $out;
	open(R,$file);
	foreach(<R>) {
		$out.=$_;
	}
	close(R);
	return $out;
}
sub http_header {
	my $http_header;
	my $nph_http_header;
	my $nph_http_header_first;

	foreach(@_) {
		$http_header.="$_\n";
	}
	$http_header=~s/\r//g;
	while($http_header=~/\n\n/) {
		$http_header=~s/\n\n/"\n"/ge;
	}
	$http_header=~s/\n$//g;
	$http_header.="\n";

	# nphXNvg̏ꍇAwb_č\z			# comment

	if($ENV{SCRIPT_NAME}=~/nph\-/) {
		my $cachecontrol=1;
		$ENV{SERVER_PROTOCOL}="HTTP/1.1" if($ENV{SERVER_PROTOCOL} eq '');
		$nph_http_header_first="$ENV{SERVER_PROTOCOL} 200 OK";
		foreach(split(/\n/,$http_header)) {
			if(/^Status/) {
				s/Status:\s*//g;
				$nph_http_header_first="$ENV{SERVER_PROTOCOL} $_";
				if($_ eq 401) {
					$nph_http_header_first=~s/\n//g;
					$nph_http_header_first.=" Authorization Required\n";
				}
			} elsif(/^Last-Modified|^Cache|^Expire/) {
				$cachecontrol=0;
				$nph_http_header.="$_\n";
			} else {
				$nph_http_header.="$_\n";
			}
		}
		$http_header=$nph_http_header_first . "\n" . $nph_http_header;
		$http_header=~s/\n\n/\n/g;
	}

	# sR[h CRLFɂ					# comment
	$http_header=~s/\x0D\x0A|\x0D|\x0A/\x0D\x0A/g;
	return "$http_header\x0D\x0A";
}

#sub http_header {
#
#	return <<EOM;
#Content-type: text/html
#
#EOM
#}

sub content_output {
	my ($h,$b)=@_;
	print <<EOM;
$h

$b
EOM
}

sub dbopen {
	my ($db,$dbfile,$dbmode)=@_;
	if($dbmode eq "w") {
		$dbmode=O_RDWR|O_CREAT;
	} else {
		$dbmode=O_RDONLY;
	}
	if(-r "$dbfile") {
		tie %$db,'GDBM_File', $dbfile,
			$dbmode, 0644
			|| die;#return 0;
	} else {
		tie %$db,'GDBM_File', $dbfile,
			$dbmode|O_CREAT, 0644
			|| die;#return 0;
	}
	return 1;
}

sub dbclose {
	my($db)=@_;
	untie(%$db);
}

sub getbasehref {
	# Thanks moriyoshi koizumi.
	return if($::basehref ne '');
	$::basehost = "$ENV{'HTTP_HOST'}";

	# SSL̏ꍇ									# comment
	if (($ENV{'https'} =~ /on/i) || ($ENV{'SERVER_PORT'} eq '443')) {
		$::basehost = 'https://' . $::basehost;
	# http̏ꍇ								# comment
	} else {
		$::basehost = 'http://' . $::basehost;
		# Special Thanks to gyo					# comment
		$::basehost .= ":$ENV{'SERVER_PORT'}"
			if ($ENV{'SERVER_PORT'} ne '80' && $::basehost !~ /:\d/);
	}

	# URL̐									# comment
	my $uri;
	my $req=$ENV{REQUEST_URI};
	$req=~s/\?.*//g;
	if($req ne '') {
		if($req eq $ENV{SCRIPT_NAME}) {
			$uri= $ENV{'SCRIPT_NAME'};
		} else {
			for(my $i=0; $i<length($ENV{SCRIPT_NAME}); $i++) {
				if(substr($ENV{SCRIPT_NAME},$i,1) eq substr($req,$i,1)) {
					$uri.=substr($ENV{SCRIPT_NAME},$i,1);
				} else {
					last;
				}
			}
		}
	} else {
		$uri .= $ENV{'SCRIPT_NAME'};
	}
	$::basehref=$::basehost . $uri;
	$::basepath=$uri;
	$::basepath=~s/\/[^\/]*$//g;
	$::basepath="/" if($::basepath eq '');
	$::script=$uri if($::script eq '');
}

sub init_form {
	$qCGI=new CGI;
	if ($qCGI->param()) {
		foreach my $var ($qCGI->param()) {
			$::form{$var} = $qCGI->param($var);
		}
	} else {
		$ENV{QUERY_STRING} = $::FrontPage;
	}

	# Thanks Mr.koizumi. v0.1.4							# comment
	my $query = $ENV{QUERY_STRING};
	if ($query =~ /&/) {
		my @querys = split(/&/, $query);
		foreach (@querys) {
			$_ = &decode($_);
			$::form{$1} = $2 if (/([^=]*)=(.*)$/);
		}
	} else {
		$query = &decode($query);
	}

	# mypreview_edit        -> do_edit, with preview.			# comment
	# mypreview_adminedit   -> do_adminedit, with preview.		# comment
	# mypreview_write       -> do_write, without preview.		# comment

	# mypreviewjs_edit        -> do_edit, with preview.			# comment
	# mypreviewjs_adminedit   -> do_adminedit, with preview.	# comment
	# mypreviewjs_write       -> do_write, without preview.		# comment

	foreach (keys %::form) {
		if (/^mypreview_(.*)$/ || /^mypreviewjs_(.*)$/) {
			if($::form{$_} ne '') {
				$::form{cmd} = $1;
				$::form{mypreview} = 1;
			}
		}
	}
#	$::form{mymsg} = &code_convert(\$::form{mymsg},   $::defaultcode,$::kanjicode) if($::form{mymsg});
}

sub make_link_puny {
	my($url)=@_;

	if($url=~/$::isurl_puny/o) {
		$url=~/(https?|ftp|news):\/\/([^:\/\#]+)(.*)/;
		my $schme=$1;
		my $host=$2;
		my $last=$3;
		my $_host="";
		if($host=~/$::isurl_puny/o) {
			foreach my $str(split(/\./,$host)) {
				if($str=~/$::isurl_puny/o) {
#					$str=&code_convert(\$str, 'utf8', $::defaultcode);
					idn_prefix('xn--');
					utf8::decode($str);
					$str=IDNA::Punycode::encode_punycode("$str") . '.';
					utf8::encode($str);
					$str=~s/\-{3,9}/--/g;
					$_host.=$str;
				} else {
					$_host.="$str.";
				}
			}
		} else {
			return $url;
		}
		$_host=~s/\.$//g;
		$url="$schme://$_host$last";
	}
	return $url;
}


sub decode {
	my ($s) = @_;
	$s =~ tr/+/ /;
#	$s =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;	# better ? # debug	# comment
	$s =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/chr(hex($1))/eg;
	# add 0.2.0-p1	# comment
	$s =~ s/%(25)/chr(hex($1))/eg;
	return $s;
}

sub encode {
	my ($encoded) = @_;
#	$encoded =~ s/(\W)/'%' . unpack('H2', $1)/eg;		# comment
	$encoded =~ s/(\W)/$::_urlescape{$1}/g;
	return $encoded;
}

sub trip {
	my ($tripkey)=shift;
#	$tripkey = "#istrip";  # gbvL[i# tj
	$tripkey = substr($tripkey,1);
	$salt = substr($tripkey.'H.',1,2);
	$salt =~ s/[^\.-z]/\./go;
	$salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
	$trip = crypt($tripkey,$salt);
#	$trip = substr($trip,-10);
	$trip =~ tr/\/:;<=>?@[\\]^_`./ABCDEFGHabcdefgh/;
#	$trip = ''.$trip;
	return $trip;
}

#$base64_alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
#                   'abcdefghijklmnopqrstuvwxyz'.
#                   '0123456789+/';
#$base64_pad = '=';
#
#$uuencode_alphabet = q|`!"#$%&'()*+,-./0123456789:;<=>?|.
#                      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_'; # double that '\\'!
#$uuencode_pad = '`';

# Build some strings for use in tr/// commands.
# Some uuencodes use " " and some use "`", so we handle both.
# We also need to protect backslashes.
#($tr_uuencode = " ".$uuencode_alphabet) =~ s/\\/\\\\/;
#$tr_base64 = "A".$base64_alphabet;


sub b64touu
{
    local ($_) = @_;
    local ($result);
    
    # zap bad characters and translate others to uuencode alphabet
    eval qq{
	tr|$tr_base64||cd;
	tr|$tr_base64|$tr_uuencode|;
    };

    # break into lines of 60 encoded chars, prepending "M" for uuencode
    while (s/^(.{60})//) {
	$result .= "M" . $& . "\n";
    }

    # any leftover chars go onto a shorter line
    # with padding to the next multiple of 4 chars
    if ($_ ne "") {
	$result .= substr($uuencode_alphabet, length($_)*3/4, 1)
		   . $_
		   . ($uuencode_pad x ((60 - length($_)) % 4)) . "\n";
    }

    # return result
    $result;
}

sub b64decode
{
    local ($_) = @_;
    local ($result);
    
    # zap bad characters and translate others to uuencode alphabet
    eval qq{
	tr|$tr_base64||cd;
	tr|$tr_base64|$tr_uuencode|;
    };

    # break into lines of 60 encoded chars, prepending "M" for uuencode,
    # and then using perl's builtin uudecoder to convert to binary.
    while (s/^(.{60})//) {
	#warn "chunk :$&:\n";
	$result .= unpack("u", "M" . $&);
    }

    # also decode any leftover chars
    if ($_ ne "") {
	#warn "last chunk :$_:\n";
	$result .= unpack("u",
		    substr($uuencode_alphabet, length($_)*3/4, 1) . $_);
    }

    # return result
    $result;
}

sub uutob64
{
    local ($_) = @_;
    local ($result);
    
    # This is the most difficult, because some perverse uuencoder
    # might have made lines that do not describe multiples of 3 bytes.
    # I don't see any better method than uudecoding to binary and then
    # b64encoding the binary.

    &b64encode(&uudecode); # implicitly pass @_ to &uudecode
}

sub b64encode
{
    local ($_) = @_;
    local ($chunk);
    local ($result);
    
    # break into chunks of 45 input chars, use perl's builtin
    # uuencoder to convert each chunk to uuencode format,
    # then kill the leading "M", translate to the base64 alphabet,
    # and finally append a newline.
    while (s/^((.|\n){45})//) {
	#warn "in:$&:\n";
	$chunk = substr(pack("u", $&), $[+1, 60);
	#warn "packed    :$chunk:\n";
	eval qq{
	    \$chunk =~ tr|$tr_uuencode|$tr_base64|;
	};
	#warn "translated:$chunk:\n";
	$result .= $chunk . "\n";
    }

    # any leftover chars go onto a shorter line
    # with uuencode padding converted to base64 padding
    if ($_ ne "") {
	#warn "length ".length($_)." \$_:$_:\n";
	#warn "enclen ", int((length($_)+2)/3)*4 - (45-length($_))%3, "\n";
	$chunk = substr(pack("u", $_), $[+1,
			int((length($_)+2)/3)*4 - (45-length($_))%3);
	#warn "chunk:$chunk:\n";
	eval qq{
	    \$chunk =~ tr|$tr_uuencode|$tr_base64|;
	};
	#warn "translated:$chunk:\n";
	$result .= $chunk . ($base64_pad x ((60 - length($chunk)) % 4)) . "\n";
    }

    # return result
    $result;
}

sub uuencode
{
    local ($_) = @_;
    local ($result);
    
    # break into chunks of 45 input chars, and use perl's builtin
    # uuencoder to convert each chunk to uuencode format.
    # (newline is added by builtin uuencoder.)
    while (s/^((.|\n){45})//) {
	$result .= pack("u", $&);
    }

    # any leftover chars go onto a shorter line
    # with padding to the next multiple of 4 chars
    if ($_ ne "") {
	$result .= pack("u", $_);
    }

    # return result
    $result;
}

sub uudecode
{
    local ($_) = @_;
    local ($result);
    
    # use perl's builtin uudecoder to convert each line
    while (s/^([^\n]+\n?)//) {
	$result .= unpack("u", $&);
    }

    # return result
    $result;
}

sub date {
	my ($format, $tm, $gmtime) = @_;
	my %weekday;
	my %ampm;

	# yday:0-365 $isdst Summertime:1/not:0
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = 
		$gmtime ne '' && @_ > 2
			? ($tm+0 > 0 ? gmtime($tm) : gmtime(time))
			: ($tm+0 > 0 ? localtime($tm) : localtime(time));

	$year += 1900;
	my $hr12=$hour=>12 ? $hour-12:$hour;

	# am / pm strings										# comment
	$ampm{en}=$::_date_ampm[$hour>11 ? 1 : 0];
	$ampm{$::lang}=$::_date_ampm_locale[$hour>11 ? 1 : 0];

	# weekday strings										# comment
	$weekday{en}=$::_date_weekday[$wday];
	$weekday{en_short}=$::_date_weekday_short[$wday];
	$weekday{$::lang}=$::_date_weekday_locale[$wday];
	$weekday{$::lang."_short"}=$::_date_weekday_locale_short[$wday];

	# RFC 822 (only this)									# comment
	if($format=~/r/) {
		return &date("D, j M Y H:i:s O",$tm,$gmtime);
	}
	# gmtime & C^[lbg							# comment
	if($format=~/[OZB]/) {
		my $gmt=&gettz;
		$format =~ s/O/sprintf("%+03d:00", $gmt)/ge;	# GMT Time	# comment
		$format =~ s/Z/sprintf("%d", $gmt*3600)/ge;		# GMT Time secs...	# comment
		my $swatch=(($tm-$gmt+90000)/86400*1000)%1000;	# GMT +1:00ɂāAP1000beatɂ	# comment
														# {Ԃ̏ꍇAAM08:00=000	# comment
		$format =~ s/B/sprintf("%03d", int($swatch))/ge;# internet time	# comment
	}

	# UNIX time
	$format=~s/U/sprintf("%u",$tm)/ge;	# unix time

	$format=~s/lL/\x2\x13/g;	# lL:escape -y			# comment
	$format=~s/DL/\x2\x14/g;	# DL:escape j-yj	# comment
	$format=~s/D/\x2\x12/g;		# D:escape Sun-Sat			# comment
	$format=~s/aL/\x1\x13/g;	# aL:escape ߑO or ߌ	# comment
	$format=~s/AL/\x1\x14/g;	# AL:escape ̑啶		# comment
	$format=~s/l/\x2\x11/g;		# l:escape Sunday-Saturday	# comment
	$format=~s/a/\x1\x11/g;		# a:escape am pm			# comment
	$format=~s/A/\x1\x12/g;		# A:escape AM PM			# comment
	$format=~s/M/\x3\x11/g;		# M:escape Jan-Dec			# comment
	$format=~s/F/\x3\x12/g;		# F:escape January-December	# comment

	# 邤NǍ̓								# comment
	if($format=~/[Lt]/) {
		my $uru=($year % 4 == 0 and ($year % 400 == 0 or $year % 100 != 0)) ? 1 : 0;
		$format=~s/L/$uru/ge;
		$format=~s/t/(31, $uru ? 29 : 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)[$mon]/ge;
	}

	# year													# comment
	$format =~ s/Y/$year/ge;	# Y:4char ex)1999 or 2003	# comment
	$year = $year % 100;
	$year = "0" . $year if ($year < 10);
	$format =~ s/y/$year/ge;	# y:2char ex)99 or 03		# comment

	# month													# comment
	my $month = ('January','February','March','April','May','June','July','August','September','October','November','December')[$mon];
	$mon++;									# mon is 0 to 11 add 1	# comment
	$format =~ s/n/$mon/ge;					# n:1-12				# comment
	$mon = "0" . $mon if ($mon < 10);
	$format =~ s/m/$mon/ge;					# m:01-12				# comment

	# day													# comment
	$format =~ s/j/$mday/ge;				# j:1-31		# comment
	$mday = "0" . $mday if ($mday < 10);
	$format =~ s/d/$mday/ge;				# d:01-31		# comment

	# hour													# comment
	$format =~ s/g/$hr12/ge;				# g:1-12		# comment
	$format =~ s/G/$hour/ge;				# G:0-23		# comment
	$hr12 = "0" . $hr12 if ($hr12 < 10);
	$hour = "0" . $hour if ($hour < 10);
	$format =~ s/h/$hr12/ge;				# h:01-12		# comment
	$format =~ s/H/$hour/ge;				# H:00-23		# comment

	# minutes												# comment
	$format =~ s/k/$min/ge;					# k:0-59		# comment
	$min = "0" . $min if ($min < 10);
	$format =~ s/i/$min/ge;					# i:00-59		# comment

	# second												# comment
	$format =~ s/S/$sec/ge;					# S:0-59		# comment
	$sec = "0" . $sec if ($sec < 10);
	$format =~ s/s/$sec/ge;					# s:00-59		# comment

	$format =~ s/w/$wday/ge;				# w:0(Sunday)-6(Saturday)	# comment

	$format =~ s/I/$isdst/ge;	# I(Upper i):1 Summertime/0:Not	# comment

	$format =~ s/\x1\x11/$ampm{en}/ge;			# a:am or pm		# comment
	$format =~ s/\x1\x12/uc $ampm{en}/ge;		# A:AM or PM		# comment
	$format =~ s/\x1\x13/$ampm{$::lang}/ge;		# A:ߑO or ߌ	# comment
	$format =~ s/\x1\x14/uc $ampm{$::lang}/ge;	# ̑啶		# comment

	$format =~ s/\x2\x11/$weekday{en}/ge;		# l(lower L):Sunday-Saturday	# comment
	$format =~ s/\x2\x12/$weekday{en_short}/ge;	# D:Mon-Sun	# comment
	$format =~ s/\x2\x13/$weekday{"$::lang" . "_short"}/ge;	# D:Mon-Sun	# comment
	$format =~ s/\x2\x14/$weekday{$::lang}/ge;

	$format =~ s/\x3\x11/substr($month,0,3)/ge;	# M:Jan-Dec				# comment
	$format =~ s/\x3\x12/$month/ge;				# F:January-December	# comment

	$format =~ s/z/$yday/ge;	# z:days/year 0-366					# comment
	return $format;

	# moved date format document to plugin/date.inc.pl or date.inc.pl.ja.pod	# comment
}
